Packager: Igor Vlasenko <viy@altlinux.ru>
BuildRequires: geronimo-jms-1.1-api
BuildRequires: /proc
BuildRequires: jpackage-compat
# Copyright (c) 2000-2009, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#


Name:           lingo
Version:        1.3
Release:        alt1_1jpp5
Epoch:          0
Summary:        Lingo Remoting and Messaging

Group:          Development/Java
License:        ASL 2.0
URL:            http://lingo.codehaus.org/
Source0:        lingo-1.3.tar.gz
# svn export http://svn.codehaus.org/lingo/tags/LINGO-1.3/ lingo-1.3

Source1:        %{name}-jpp-depmap.xml
Source2:        %{name}-settings.xml
Patch0:         %{name}-lingo-pom.patch
Patch1:         %{name}-WriteLockDeadLockTest.patch
Patch2:         %{name}-WriteLockTest.patch


BuildArch:      noarch
BuildRequires: jpackage-utils >= 0:1.7.5
BuildRequires: maven2 >= 0:2.0.7
BuildRequires: maven2-plugin-assembly
BuildRequires: maven2-plugin-compiler
BuildRequires: maven2-plugin-install
BuildRequires: maven2-plugin-jar
BuildRequires: maven2-plugin-javadoc
BuildRequires: maven2-plugin-resources
BuildRequires: maven-surefire-plugin
BuildRequires: geronimo-genesis

BuildRequires: acegi-security
BuildRequires: activemq4
BuildRequires: activemq4-ra
BuildRequires: hsqldb
BuildRequires: geronimo-j2ee-management-1.0-api
BuildRequires: jakarta-commons-dbcp
BuildRequires: jakarta-commons-pool
BuildRequires: jencks
BuildRequires: junit
BuildRequires: log4j
BuildRequires: mx4j
BuildRequires: spring-mock
BuildRequires: sysunit
BuildRequires: xapool

BuildRequires: activeio3
BuildRequires: backport175
BuildRequires: backport-util-concurrent
BuildRequires: derby
BuildRequires: geronimo-txmanager
BuildRequires: jakarta-commons-collections
BuildRequires: jakarta-commons-logging
BuildRequires: j2ee_connector_1_5_api
BuildRequires: j2ee_management_1_1_api
BuildRequires: jms_1_1_api
BuildRequires: servlet_2_4_api
BuildRequires: spring
BuildRequires: xbean
BuildRequires: xstream

Requires: activeio3
Requires: backport175
Requires: backport-util-concurrent
Requires: geronimo-txmanager
Requires: jakarta-commons-collections
Requires: jakarta-commons-logging
Requires: j2ee_connector_1_5_api
Requires: j2ee_management_1_1_api
Requires: jms_1_1_api
Requires: servlet_2_4_api
Requires: xbean
Requires: xstream

Requires(post): jpackage-utils >= 0:1.7.5
Requires(postun): jpackage-utils >= 0:1.7.5

%description
Lingo is a lightweight POJO based remoting and messaging 
library based on Spring's Remoting which extends it to 
support JMS. Lingo can support a wide range of message 
exchange patterns including both synchronous and asynchronous
message exchange.
Lingo is an ideal technology to cluster your POJO services 
to achieve load balancing across many servers and automatic 
failover. Lingo is high performance and works great in server 
centric environments as it can work with JCA to cleanly 
integrate with thread, connection and session pooling as well 
as handing of transactions, retry and exception handling.
Lingo now has SCA Support for working with the SCA annotations.
Current supported message exchange patterns include
* synchronous request-response (like RMI)
* one way messaging (asynchronous invocation - 
  like a JMS publish)
* asynchronous consumption (like a JMS subscribe)
* asynchronous request-reply (allowing the server side to 
  asynchronously send one or more replies as the data becomes 
  available).
You can think of Lingo as being conceptually similar to both
Microsoft Indigo and JSR 181 in that it allows asynchrnous 
method execution, remoting and asynchronous messaging to be 
bound to existing POJOs (classes or interfaces) though it has 
no particular dependency on Web Services infrastructure.
Lingo supports pluggable messaging bindings; the first binding 
is an efficient JMS implementation. Over time we'll be adding 
other bindings to web services frameworks and other transports.

%package        javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
BuildArch: noarch

%description    javadoc
%{summary}.

%prep
%setup -q 
%patch0 -b .sav0
%patch1 -b .sav1
%patch2 -b .sav2

%build
cp %{SOURCE2} maven2-settings.xml

sed -i -e "s|<url>__JPP_URL_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__JAVADIR_PLACEHOLDER__</url>|<url>file://`pwd`/external_repo</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENREPO_DIR_PLACEHOLDER__</url>|<url>file://`pwd`/m2_repo/repository</url>|g" maven2-settings.xml
sed -i -e "s|<url>__MAVENDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/maven2/plugins</url>|g" maven2-settings.xml
sed -i -e "s|<url>__ECLIPSEDIR_PLUGIN_PLACEHOLDER__</url>|<url>file:///usr/share/eclipse/plugins</url>|g" maven2-settings.xml

mkdir external_repo
ln -s %{_javadir} external_repo/JPP

export M2SETTINGS=$(pwd)/maven2-settings.xml
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
mkdir -p $MAVEN_REPO_LOCAL/org.logicblaze.lingo/
ln -sf $MAVEN_REPO_LOCAL/org/logicblaze/lingo/lingo/1.3/lingo-1.3.jar $MAVEN_REPO_LOCAL/org.logicblaze.lingo/lingo.jar

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Dmaven.test.failure.ignore=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        install

mvn-jpp -e \
        -s ${M2SETTINGS} \
        -Daggregate=true \
        -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        javadoc:javadoc


%install
install -dm 755 $RPM_BUILD_ROOT%{_javadir}
install -dm 755 $RPM_BUILD_ROOT%{_datadir}/maven2/poms

install -m 644 lingo/target/lingo-%{version}.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -m 644 pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}-parent.pom
%add_to_maven_depmap org.logicblaze.lingo lingo-parent %{version} JPP %{name}-parent
install -m 644 lingo/pom.xml $RPM_BUILD_ROOT%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.logicblaze.lingo lingo %{version} JPP %{name}

# javadoc
install -dm 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

%files
%{_javadir}/%{name}-%{version}.jar
%{_javadir}/%{name}.jar
%doc lingo/{LICENSE,README}.txt
%{_datadir}/maven2/poms/*
%{_mavendepmapfragdir}/*

%files javadoc
%doc %{_javadocdir}/%{name}-%{version}
%doc %{_javadocdir}/%{name}

%changelog
* Sun Mar 28 2010 Igor Vlasenko <viy@altlinux.ru> 0:1.3-alt1_1jpp5
- new version

